from tkinter import*
from os.path import expanduser, split
from xlrd.sheet import ctype_text
import tkinter.ttk as ttk
import tkinter.messagebox as tkMessageBox
import sqlite3
import os
import time
import datetime
import sys
import tempfile
import tkinter.filedialog as filedialog
import xlrd

exeversion = 'v. 1.21' 

def select_file(top, tree, def_dur):
    dbpath = os.path.expanduser("~")+'/Documents'
    fullname = filedialog.askopenfilename(initialdir = dbpath,
                                          title = "Select an Excel file" )
    if fullname:
        excel_filename = split(fullname)[1]
        dbpath = split(fullname)[0]
        if excel_filename[-4:].lower() == '.xls' or excel_filename[-5:].lower() == '.xlsx' :
            create_ics(dbpath, excel_filename, top, tree, def_dur)
        else:
            tkMessageBox.showerror("Error",
                                   excel_filename+' is not an Excel file ')
            select_file(top, tree, def_dur)
    #else:
    #    root.destroy()


def create_ics(dbpath, excel_filename, top, tree, def_dur):
    if excel_filename[-4:].lower() == '.xls':
        ics_filename = excel_filename[:-4].lower() + '.ics'
    if excel_filename[-5:].lower() == '.xlsx' :
        ics_filename = excel_filename[:-5].lower() + '.ics'

    result = tkMessageBox.askquestion('','Creating '+ics_filename+' ?' ,
                                      icon="info")
    if result == 'yes': 
        os.chdir(dbpath)
        if os.path.isfile(ics_filename):
            tkMessageBox.showerror("Error", ics_filename+' already exists')
        else:
            read_excel(dbpath, excel_filename, ics_filename, top, tree, def_dur)


def read_excel(dbpath, excel_filename, ics_filename, top, tree, def_dur):
    os.chdir(dbpath)
    xl_workbook = xlrd.open_workbook(excel_filename)
    sheet_names = xl_workbook.sheet_names()
    xl_sheet = xl_workbook.sheet_by_index(0)

    def write(txt):
        ics.append(txt)
        
    def cell(cell_obj):
        date = None
        time = None
        intg = None
        real = None
        text = None
        tim2 = None

        cell_type   = ctype_text.get(cell_obj.ctype, 'unknown type')
        cell_value  = cell_obj.value

        if cell_type == 'xldate':
            if cell_value > 365:
                a1_as_datetime = str (
                    datetime.datetime(*xlrd.xldate_as_tuple(
                        cell_value, xl_workbook.datemode)))
                #date = a1_as_datetime[0:4]+a1_as_datetime[5:7]+a1_as_datetime[8:10]
                date = a1_as_datetime[0:10]
            # if cell_value >= 0:
            if cell_value <= 365 and cell_value >= 0:
                a1_as_datetime = str (
                    datetime.datetime(*xlrd.xldate_as_tuple(
                        cell_value+367, xl_workbook.datemode)))
                #time = a1_as_datetime[11:13]+a1_as_datetime[14:16]+a1_as_datetime[17:19]
                time = a1_as_datetime[11:19]
                a1_as_datetime = str (
                    datetime.datetime(*xlrd.xldate_as_tuple(
                        cell_value+367+default_duration, xl_workbook.datemode)))
                #tim2 = a1_as_datetime[11:13]+a1_as_datetime[14:16]+a1_as_datetime[17:19]
                tim2 = a1_as_datetime[11:19]
        if cell_type == 'number':
            if cell_value == int(cell_value) :
                intg = int(cell_value)
            else:
                real = cell_value
        if cell_type == 'text':
                text = cell_value
##      if cell_type != 'empty':  ...

        return cell_value, cell_type, date, time, tim2, intg, real, text   

##      expected : date_from, time_from, date_to, time_to, location, descr, note, warning_before

    ics = list()
    try: 
        tmp = int(def_dur.get())
    except:
        tmp = 2
    if tmp < 1:
        tmp = 1
    if tmp > 24:
        tmp = 24
    def_dur.set(tmp)            

    default_duration = int(def_dur.get())/24 # 1 H

    # for ro in range(1, xl_sheet.nrows):  # from 1 ignore title
    for ro in range(0, xl_sheet.nrows):  
        # row = list()
        datelist = list()
        timelist = list()
        tim2list = list()
        intglist = list()
        textlist = list()
        uid_list = None

        n = -1
        for co in range(0, xl_sheet.ncols):
            n = n + 1
            cell_obj = xl_sheet.cell(ro, co)
            cell_value, cell_type, date, time, tim2, intg, real, text = cell(cell_obj)

            if co == 0 and not date:
                uid_list = str(cell_value)
            else:
                if date:
                    datelist.append(date)
                if time:
                    timelist.append(time)
                    tim2list.append(tim2)
                if real:
                    intg = int(real)
                    intglist.append(real)
                if intg:
                    intglist.append(intg)
                if text:
                    textlist.append(text)

        if len(datelist) == 1:
            datelist.append(datelist[0])
        if len(timelist) == 1:
            timelist.append(tim2list[0])
        if len(textlist) == 0:
            textlist.append('No text defined')

        if len(datelist) > 0 and len(timelist) > 0 :

            write('BEGIN:VEVENT')
            ## write('ORGANIZER:MAILTO: ...@...')
            write('DTSTART:'+datelist[0][0:4]+datelist[0][5:7]+datelist[0][8:10]+'T'+timelist[0][0:2]+timelist[0][3:5]+timelist[0][6:8])
            write('DTEND:'+datelist[1][0:4]+datelist[1][5:7]+datelist[1][8:10]+'T'+timelist[1][0:2]+timelist[1][3:5]+timelist[1][6:8])

            row = [ datelist[0], timelist[0], datelist[1], timelist[1], '', '', '', '' , '' ]

            if len(textlist) == 1: # descr
                write('SUMMARY;ENCODING=QUOTED-PRINTABLE:'+textlist[0])
                row[6] = textlist[0]
            if len(textlist) == 2: # location, descr
                write('LOCATION;ENCODING=QUOTED-PRINTABLE:'+textlist[0])
                write('SUMMARY;ENCODING=QUOTED-PRINTABLE:'+textlist[1])
                row[5] = textlist[0]
                row[6] = textlist[1]

            if len(textlist) >= 3: # location, descr, note, 
                write('LOCATION;ENCODING=QUOTED-PRINTABLE:'+textlist[0])
                write('SUMMARY;ENCODING=QUOTED-PRINTABLE:'+textlist[1])
                write('DESCRIPTION;ENCODING=QUOTED-PRINTABLE:'+textlist[2])
                row[5] = textlist[0]
                row[6] = textlist[1]
                row[7] = textlist[2]

            if uid_list:
                write('UID:'+uid_list)
                row[8] = uid_list
                
            write('PRIORITY:5')
            write('X-MICROSOFT-CDO-')
            write('IMPORTANCE:1')

            if len(intglist) > 0:
                write('CLASS:PUBLIC')
                write('BEGIN:VALARM')
                # TRIGGER:-PT15M
                write('TRIGGER:-PT'+str( int(intglist[0]) )+'M')
                write('ACTION:DISPLAY')
                write('END:VALARM')
                row[4] = int(intglist[0])

            write('END:VEVENT')

        else:
            row = [ '*** Error ***', '', '', '', '', '', '', '' , '' ]

        tree.insert('', 'end',values=row)
        # tree["displaycolumns"]=(title_to_display)

    Button(top,text='Generate ICS', width=20, command=lambda:generate_ics(
        dbpath, excel_filename, ics_filename, top, tree, def_dur, ics)).grid(
        row=1, column=4)


def generate_ics(dbpath, excel_filename, ics_filename, top, tree, def_dur, ics):

    try:
        tmpf = open(ics_filename, "w")   
        tmpf.write('BEGIN:VCALENDAR'+'\n')
        tmpf.write('VERSION:2.0'+'\n')
        tmpf.write('PRODID:-//Quintilien//Quintilien//EN'+'\n')
        tmpf.write('PRODID:-//Apple Inc.//Mac OS X 10.9.5//EN'+'\n')
        tmpf.write('METHOD:PUBLISH'+'\n')
        for li in ics:
            tmpf.write(li+'\n')
        tmpf.write('END:VCALENDAR'+'\n')
        tmpf.close()    
    except:
        tkMessageBox.showerror("Error", 'Unable to create file')

    Label(top,text='    File "'+ics_filename+'"      ', font =('',16)).grid(
        row=0, column=0, padx= 80)
    Label(top,text=' * * *  CREATED * * * ', font =('',16)).grid(
        row=1, column=0, padx= 80)


def main():

    screen_width = root.winfo_screenwidth()  
    screen_height = root.winfo_screenheight()
    width = 900
    height = 550
    x = (screen_width/2) - (width/2)
    y = (screen_height/2) - (height/2)
    root.geometry('%dx%d+%d+%d' % (width, height, x - 20, y  - 40))
    root.option_add("*Button.Width", "14")

    top = Frame(root)
    top.pack(side=TOP)
    bottom = Frame(root)
    bottom.pack(side=BOTTOM)
    mid = Frame(root)
    mid.pack(side=BOTTOM, fill='x')

    Label(top,text='Ready to convert', font =('',16)).grid(
        row=0, column=0, padx= 80)
    Label(top,text='Excel file to .ics file', font =('',16)).grid(
        row=1, column=0, padx= 80)
    
    Label(top,text=exeversion, pady=10).grid(
        row=0, column=1, padx= 10)

    Label(top,text='Default duration = ', pady=10).grid(
        row=1, column=1, sticky=S)

    Button(top,text='Quit', width=20, command = root.destroy).grid(
        row=0, column=4, padx=80)

    Button(top,text='Select Excel file', width=20,
        command=lambda:select_file(top, tree, def_dur)).grid(
        row=1, column=4)

    def valid_def_dur():
        try: 
            tmp = int(def_dur.get())
        except:
            tmp = 2
        if tmp < 1:
            tmp = 1
        if tmp > 24:
            tmp = 24
        def_dur.set(tmp)            

    def_dur = StringVar()
    def_dur.set(2)
    entr_dur = Entry (top, textvariable=def_dur, width=2)
    entr_dur.grid(row=1, column = 2)
    entr_dur.bind('<Tab>', lambda tmp:valid_def_dur())
    entr_dur.bind('<Return>', lambda tmp:valid_def_dur())
    
    scrollbary = Scrollbar(mid, orient=VERTICAL)
    scrollbarx = Scrollbar(mid, orient=HORIZONTAL)
    tree = ttk.Treeview(mid, height=500, show='headings', \
                        yscrollcommand=scrollbary.set, \
                        xscrollcommand=scrollbarx.set)

    scrollbary.config(command=tree.yview)
    scrollbary.pack(side=RIGHT, fill=Y)
    scrollbarx.config(command=tree.xview)
    scrollbarx.pack(side=BOTTOM, fill=X)
    tree.pack(fill='x')


    title_to_display = [
        'From','','To','','Alarm','Location','Summary','Note','UID']
        #tree["displaycolumns"]= list() # bug if "columns" change when display already exists
    tree["columns"]= ( title_to_display )
    #tree["displaycolumns"]= title_to_display     
        
    tree.column('#0', stretch=NO, minwidth=10, width=100)
    for i, tit in enumerate (title_to_display):
        tree.heading('#'+str(i+1), text=tit, anchor=W)
        if i == 4:
            tree.heading('#'+str(i+1), text=tit, anchor=CENTER)
        col_width    = [85, 65, 85, 65, 40, 120, 220, 150, 100]
        col_minwidth = [85, 65, 85, 65, 30, 50, 150, 200, 10]
    
        tree.column('#'+str(i+1), stretch=NO, minwidth=col_minwidth[i], width=col_width[i])
        if i == 4 :
            tree.column('#'+str(i+1), stretch=NO, anchor=CENTER, minwidth=col_minwidth[i], width=col_width[i])
        tree.delete(*tree.get_children())
    
if __name__ == '__main__':
    root = Tk()
    root.title('Excel to ICS')
    main()
    root.mainloop()
